unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Db, DBTables, BDE, ExtCtrls, EDBUtil;

type
  TForm1 = class(TForm)
    DBUtil1: TEvDBUtil;
    RGrpAcao: TRadioGroup;
    GroupBox1: TGroupBox;
    ProgressBar1: TProgressBar;
    LabFile: TLabel;
    LabAcao: TLabel;
    BtnAcao: TButton;
    BtnCancela: TButton;
    procedure DBUtil1Process(Sender: TObject; FileName: string);
    procedure DBUtil1Error(Sender: TObject; Error: TEvDBError; FileName: string);
    procedure RGrpAcaoClick(Sender: TObject);
    procedure BtnAcaoClick(Sender: TObject);
    procedure BtnCancelaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DBUtil1Start(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  DBUtil1.DatabaseNames := ExtractFilePath(Application.ExeName);
end;

procedure TForm1.RGrpAcaoClick(Sender: TObject);
begin
  BtnAcao.Caption := RGrpAcao.Items[RGrpAcao.ItemIndex];
  case RGrpAcao.ItemIndex of
    0: LabAcao.Caption := 'Inicializando';
    1: LabAcao.Caption := 'Reindexando';
    2: LabAcao.Caption := 'Compactando';
  end;
end;

procedure TForm1.BtnAcaoClick(Sender: TObject);
var
  R: Boolean;
begin
  BtnCancela.Enabled := True;
  R := False;
  case RGrpAcao.ItemIndex of
    0: R := DBUtil1.Initialize;
    1: R := DBUtil1.Reindex;
    2: R := DBUtil1.Pack;
  end;
  if DBUtil1.Aborted then
    ShowMessage('O processo foi abortado pelo usurio.')
  else if R then
    ShowMessage('Processo concludo com sucesso.')
  else
    ShowMessage('Ocorreram erros durante o processo.');
  BtnCancela.Enabled := False;
  ProgressBar1.Position := 0;
  LabFile.Caption := 'C:\';
end;

procedure TForm1.BtnCancelaClick(Sender: TObject);
begin
  DBUtil1.Abort;
end;

procedure TForm1.DBUtil1Error(Sender: TObject; Error: TEvDBError; FileName: string);
var
  S: string;
begin
  case Error of
    deSaveInfo: S := 'Erro salvando o arquivo de informaes:';
    deDeleteFile: S := 'Erro deletando o arquivo:';
    deTableBusy: S := 'Esta tabela est sendo usada:';
    deAddIndex: S := 'Erro ao adicionar ndice  tabela:';
    deResetdBase: S := 'Erro ao resetar o arquivo dBase:';
    dePackTable: S := 'Erro ao compactar a tabela:';
    deInvalidType: S := 'Tipo de tabela invlido:';
    deCantOpen: S := 'Erro ao tentar abrir a tabela:';
  end;
  ShowMessage(S + #13 + FileName);
end;

procedure TForm1.DBUtil1Process(Sender: TObject; FileName: String);
begin
  LabFile.Caption := FileName;
  ProgressBar1.Position := ProgressBar1.Position + 1;
  Application.ProcessMessages;
end;

procedure TForm1.DBUtil1Start(Sender: TObject);
begin
  if MessageDlg('Confirma o processamento de ' + IntToStr(DBUtil1.Files.Count) +
    ' tabelas?', mtConfirmation, [mbYes, mbNo], 0) <> mrYes then
    DBUtil1.Abort
  else
    ProgressBar1.Max := DBUtil1.Files.Count;
end;

end.

